<?php

namespace DropshippingExportFreeVendor\WPDesk\Library\DropshippingExport\PriceCompare\ProductFields\Nokaut;

use DOMElement;
use DropshippingExportFreeVendor\WPDesk\Library\DropshippingExport\PriceCompare\ProductFields\CustomProductField;
use DropshippingExportFreeVendor\WPDesk\Library\DropshippingExport\ProductFields\ProductField;
use DropshippingExportFreeVendor\WPDesk\Library\DropshippingExport\ProductFields\ProductFieldValue;
use DropshippingExportFreeVendor\WPDesk\Library\DropshippingExport\ProductFields\ProductFieldXml;
use DropshippingExportFreeVendor\WPDesk\Library\DropshippingExport\ProductFields\Value\AttributesProductFieldValue;
class AttributesProductField extends CustomProductField implements ProductField, ProductFieldXml
{
    public const SINGLE_ATTR_TAG = 'property';
    public const SINGLE_ATTR_TAG_NAME = 'name';
    private string $field_name;
    private ProductFieldValue $product_value;
    public function __construct(ProductFieldValue $product_value)
    {
        $this->product_value = $product_value;
    }
    public static function get_default_class_value(): string
    {
        return AttributesProductFieldValue::class;
    }
    public static function is_allowed_to_change(): bool
    {
        return \true;
    }
    public static function get_default_field_name(): string
    {
        return 'product_attributes';
    }
    public static function get_default_field_nice_name(): string
    {
        return sprintf(esc_html__('Attributes %s', 'dropshipping-export-free'), '(' . self::SINGLE_ATTR_TAG . ')');
    }
    public function get_field_name(): string
    {
        $default = self::get_default_field_name();
        return !empty($this->field_name) ? $this->field_name : $default;
    }
    public function set_field_name(string $string)
    {
        $this->field_name = trim($string);
    }
    public function map_xml_value(DOMElement $element): DOMElement
    {
        $root = $element->ownerDocument;
        $values = $this->get_values_as_array($this->product_value);
        if (\is_array($values)) {
            foreach ($values as $key => $value) {
                $a = $element->appendChild($root->createElement(self::SINGLE_ATTR_TAG));
                $a->setAttribute(self::SINGLE_ATTR_TAG_NAME, (string) $key);
                $a->appendChild($root->createCDATASection((string) $value));
            }
        }
        return $element;
    }
}
